<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
   <HEAD>
      <META HTTP-EQUIV="Pragma" CONTENT="no cache">
      <META NAME="Organization" CONTENT="The Scripps Research Institute">
      <META NAME="Copyright" CONTENT="The Scripps Research Institute">
      <META NAME="Version" CONTENT="1">
      <META NAME="Author" CONTENT="Jesus M. Castagnetto, jesusmc@scripps.edu">
      <META NAME="Keywords" CONTENT="metal, protein, metalloprotein, protein
                                     design, structure, database, molecular
                                     biology, metalloenzyme, metalloantibody,
                                     database, query, java">
      <META NAME="Description" CONTENT="A structural database of metal-binding
                                        sites in metalloproteins, including an
                                        interactive search and visualization
                                        interface.">
      <TITLE>
         MDB (Query Results) - Metalloprotein Site Database and Browser
      </TITLE>
      <SCRIPT TYPE="text/javascript" LANGUAGE="JavaScript"
              SRC="/javascript/mainbar.js">
      </SCRIPT>
   </HEAD>
   <BODY BGCOLOR="#FFFFFF">
      <TABLE BORDER=0 CELLSPACING=0 WIDTH="100%">
         <TR> 
            <TD COLSPAN=2>
               <?php virtual ("../include/navhead.inc") ?>
            </TD>
         </TR>
         <TR VALIGN="top">
            <TD BGCOLOR="#06F6FA" ROWSPAN=2>
               <?php virtual ("../include/navside.inc") ?>
            </TD>
            <TD><HR>
               <?php virtual ("../include/logo.inc") ?>
               <!-- END of MDB Logo -->
               <HR><H2 ALIGN="CENTER">Results of querying the MDB</H2>
               <?php
                  /* Script: prev_next.php
                   * simple script to implement the "Previous results",
                   * "Next results" buttons
                   *
                   * Written by: Jesus M. Castagnetto
                   * Created on: Feb 01, 1999
                   */
    
                  /* included scripts are in the /php_inc/ dir */
                  require ("sql.inc");
                  require ("tables.inc");
    
                  /* (hidden) variables passed to the script:
                   * form_str = a string w/ the form entry
                   * sql_str = a string w/ the SQL query
                   * max = maximum number of hits per page
                   * lower,upper = bounds for the results range
                   */

                  $db = "metallodb";
                  $query = urldecode($sql_str);
                  $form = urldecode ($form_str);
                  $link = SQL_pconnect();
                  $result = SQL($db,$query . " LIMIT " . $upper ,$link); 
                  echo (urldecode($form_str));
                  if ($result) {
                     /* we got some hits */
                     $leftlower = max(1,$lower - $max);
                     $leftupper = $lower - 1;
                     $rightlower = $upper + 1;
                     $rightupper = min((int)$nrows,(int)($upper + $max));
	
                     $showing = "<P><DIV ALIGN=\"CENTER\"><B><U>
                                 Showing results: " . (int) $lower;
                     $showing .= " to " . (int) $upper . "</U></B></DIV>";
                     echo ($showing);
                     echo ("<DIV ALIGN=\"CENTER\">\n
                            <TABLE WIDTH=\"90%\">\n<TR>\n");
                     if ($leftupper > 0) {
                        echo ("<TD ALIGN=\"LEFT\">\n");
                        makeForm(urlencode($form), urlencode($query), $nrows,
                                 $max, $leftlower, $leftupper);
                        echo ("</TD>\n");
                     }
                     if ($rightlower <= $nrows) {
                        echo ("<TD ALIGN=\"RIGHT\">\n");
                        makeForm(urlencode($form), urlencode($query), $nrows,
                                 $max, $rightlower, $rightupper);
                        echo ("</TD>\n");
                     }
                     echo("</TR>\n</TABLE>\n</DIV>");
	
                     makeTable($result, $max, $lower, $upper);
                     echo ("<DIV ALIGN=\"CENTER\">\n
                            <TABLE WIDTH=\"90%\">\n<TR>\n");
                     if ($leftupper > 0) {
                        echo ("<TD ALIGN=\"LEFT\">\n");
                        makeForm(urlencode($form), urlencode($query), $nrows,
                        $max, $leftlower, $leftupper);
                        echo ("</TD>\n");
                     }
                     if ($rightlower <= $nrows) {
                        echo ("<TD ALIGN=\"RIGHT\">\n");
                        makeForm(urlencode($form), urlencode($query), $nrows,
                        $max, $rightlower, $rightupper);
                        echo ("</TD>\n");
                     }
                     echo("</TR>\n</TABLE>\n</DIV>");
                  } else { 
                     echo ("<BR>No sites with those characteristics were found,
                            try again<BR>\n");
                  }
                  if ($result) SQL_free_result($result);
               ?>
            </TD>
         </TR>
         <TR>
            <TD ALIGN="CENTER" BGCOLOR="#E0FFFF">
               <HR WIDTH="50%">
               <?php virtual ("/include/nav_mdb_text.inc") ?>
               <HR WIDTH="50%">
            </TD>
         </TR>
         <TR>
            <TD COLSPAN=2 BGCOLOR="#06F6FA" ALIGN="CENTER">
               <?php virtual ("/include/navfoot.inc") ?>
            </TD>
         </TR>
      </TABLE><HR>
      <ADDRESS>
         <SMALL>
            Page maintained by Jesus M.
            Castagnetto (jesusmc@scripps.edu) -
            &copy; The Scripps Research Institute. <BR>
            Query performed on: <?php echo (date("D, F d, Y - h:i a",time())) ?>
         </SMALL>
      </ADDRESS>
   </BODY>
</HTML>
